
#include<stdio.h>
#include<stdlib.h>
#include<string.h>
#include<unistd.h>
#include<sys/uio.h>
#include"debug.h"

Debug::Debug():lb(ms,512),ostream(&lb)
{
  level_=0;prefix_="";
  lb.initcb(callback,this);
}

Debug::Debug(char *prefix):lb(ms,512),ostream(&lb),prefix_(prefix),level_(0)
{
  lb.initcb(callback,this);
}

void Debug::callback(void *data,char *str,int l)
{
  Debug *self = (Debug *)data;
  struct iovec io[3];
  io[0].iov_base=self->prefix_;  io[0].iov_len=strlen(self->prefix_);
  io[1].iov_base=(void *)":";    io[1].iov_len=1;
  io[2].iov_base=str;            io[2].iov_len=l;
  ::writev(2,io,3);
}

void Debug::message(int minlevel,char *format,...)
{
  va_list ap;
  char *rformat = (char *)alloca(strlen(format)+strlen(prefix_)+1);
  va_start(ap,format);
  if(level(minlevel))
  {
    strcpy(rformat,prefix_);
    strcat(rformat,":");
    strcat(rformat,format);
    vfprintf(stderr,rformat,ap);
  }
  va_end(ap);
}

EnvDebug::EnvDebug(char *prefix,const char *modulename):Debug(prefix),name_(modulename)
{
  int l=strlen(name_)+5;
  char *envname=(char *)alloca(l);
  snprintf(envname,l,"DBG_%s",name_);
  char *v = getenv(envname);
  if(v==NULL) v = getenv("DBG_ALL");
  if(v!=NULL)
  {
    level_=atoi(v);
  }
}

#ifdef DEBUGTEST
static EnvDebug envdebug("debugtest","debugtest");

struct S
{
  const char *name;
  double wert;
  S(const char *n,double w):name(n),wert(w) {}
};

ostream& operator<<(ostream& str,const S& s)
{
  str << s.name << " " << s.wert;
  return str;
}

int main(int argc,char **argv)
{
  envdebug.message(1,"Level 1\n");
  envdebug.message(2,"Level 2\n");
  if(envdebug.level(1))
  {
    envdebug << "Eine Zahl 15 in hex " << hex << 15 << endl;
    S s("Rudolf",1.84);
    envdebug << "Struktur: " << s << endl;
  }
}
#endif





