#ifndef DEBUG__H
#define DEBUG__H
/**
 * @file debug.h
 * @author <A href="http://www.infnet.verein.de/~rw/">Rudolf Weber</A>
 * @copyright 2002 Informatik- und Netzwerkverein Ravensburg e.V
 * nach GNU Copyleft
 */
#include<iostream.h>
#include"logbuf.h"

/**
 * \brief Debugausgabe
 * durch die Ableitung von ostream kann man mit dem Stream-Operator
 * &gt;&gt; wie bei cerr Sachen hineinschieben.
 * 
 * Die Klasse soll ein allgemeines Interface sein.
 * Die Ausgabe erfolgt zur Zeit in stderr.
 * Im Prinzip knnte sie auch ber syslog oder hnliche Mechanismen
 * auggefhrt werden.
 *
 * Vielleicht sind hier zwei Konzepte vermischt:
 *  - Logger
 *  - Debug
 *
 * Andererseits knnte man auch negative levels definieren
 * fr warning : 0
 * fr error:   -1
 */
class Debug: public ostream
{
private: 
  logbuf lb;
  char ms[512];
  char *prefix_;
protected:
  int level_;
public:
  Debug();
  Debug(char *prefix);
  void setlevel(int l) { level_=l; }
  int level() { return level_; }
  bool level(int min) { return min <= level_ ; }
  void message(int minlevel,char *format,...);
  
  static void callback(void *data,char *str,int l);
};

/**
 * setzt Debuglevel nach DBG_<I>modulename</I>
 * Nach einer Idee von O.K.
 */
class EnvDebug : public Debug
{
  const char *name_;
public:
  EnvDebug(char *prefix,const char *modulename);
};

#endif




