#include"logbuf.h"

#if __GNUC__==3
logbuf::logbuf(char *buf,int len)
{
    // selbsthilfe:
    p=puffer=buf;
    rest=plen=len;
    cb=(logbufcallback)NULL;
}

void logbuf::reinit()
{
    rest=plen;
    p=puffer;
}

int logbuf::uebernehmen(char *str,int len)
{
    char *pq=str;
    char *pm=p;
    int rlen=0;
    if(str == NULL || len == 0) return 0; // es kommt str==NULL !!!!
    
    while(pq<str+len && *pq!='\0'&& rest > 0)
    {
	if(*pq == '\n')
	{
	  *p++=*pq++;
	  *p='\0';
	  rlen += p-pm+1;
	  if(cb!=NULL) (*cb)(cbdata,puffer,p-puffer);
	  reinit();
	  pm=p;
	  pq++;
	}
	else
	{
	  *p++=*pq++;
	  rest--;
	}
    }
    *p='\0';
    rlen += p-pm; 
    return rlen;
}

int logbuf::overflow(int_type ch)
{
    if(ch != EOF)
    {
	char cbuf[1];
	cbuf[0]=ch;
	if(uebernehmen(cbuf,1)!=1) return EOF;
    }
    return 0;
}

#else
logbuf::logbuf(char *buf,int len)
{
    // hilft nix :-(
    linebuffered(1);
    unbuffered(1);

    // selbsthilfe:
    p=puffer=buf;
    rest=plen=len;
    cb=(logbufcallback)NULL;
}

void logbuf::reinit()
{
    rest=plen;
    p=puffer;
}

int logbuf::uebernehmen(char *str,int len)
{
    char *pq=str;
    char *pm=p;
    int rlen=0;
    if(str == NULL || len == 0) return 0; // es kommt str==NULL !!!!
    
    while(pq<str+len && *pq!='\0'&& rest > 0)
    {
	if(*pq == '\n')
	{
	    *p='\0';
	    rlen += p-pm+1;
	    if(cb!=NULL) (*cb)(cbdata,puffer,p-puffer);
	    reinit();
	    pm=p;
	    pq++;
	}
	else
	{
	    *p++=*pq++;
	    rest--;
	}
    }
    *p='\0';
    rlen += p-pm; 
    return rlen;
}

int logbuf::sync()
{
    streamsize n = pptr() - pbase();
    int nw=uebernehmen(pbase(),n);
    return (n && nw != n) ? EOF : 0;
}

int logbuf::overflow(int ch)
{
    streamsize n = pptr() - pbase();
    if(n && sync()) return EOF;
    if(ch != EOF)
    {
	char cbuf[1];
	cbuf[0]=ch;
	if(uebernehmen(cbuf,1)!=1) return EOF;
    }
    pbump(-n); // reset pptr;
    return 0;
}

streamsize logbuf::xsputn(char *text,streamsize n)
{
    return sync()==EOF ? 0 : uebernehmen(text,n);
}
#endif







